
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class App_menusDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const app_menus = await db.app_menus.create(
            {
                id: data.id || undefined,
        
        key: data.key
        ||
        null
            ,
            
        title: data.title
        ||
        null
            ,
            
        route: data.route
        ||
        null
            ,
            
        parent_key: data.parent_key
        ||
        null
            ,
            
        sort_order: data.sort_order
        ||
        null
            ,
            
        is_visible: data.is_visible
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return app_menus;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const app_menusData = data.map((item, index) => ({
                id: item.id || undefined,
                
                key: item.key
            ||
            null
            ,
            
                title: item.title
            ||
            null
            ,
            
                route: item.route
            ||
            null
            ,
            
                parent_key: item.parent_key
            ||
            null
            ,
            
                sort_order: item.sort_order
            ||
            null
            ,
            
                is_visible: item.is_visible
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const app_menus = await db.app_menus.bulkCreate(app_menusData, { transaction });

        // For each item created, replace relation files
        

        return app_menus;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const app_menus = await db.app_menus.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.key !== undefined) updatePayload.key = data.key;
        
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.route !== undefined) updatePayload.route = data.route;
        
        
        if (data.parent_key !== undefined) updatePayload.parent_key = data.parent_key;
        
        
        if (data.sort_order !== undefined) updatePayload.sort_order = data.sort_order;
        
        
        if (data.is_visible !== undefined) updatePayload.is_visible = data.is_visible;
        
        
        updatePayload.updatedById = currentUser.id;

        await app_menus.update(updatePayload, {transaction});

        
        

        
        

        

        return app_menus;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const app_menus = await db.app_menus.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of app_menus) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of app_menus) {
                await record.destroy({transaction});
            }
        });


        return app_menus;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const app_menus = await db.app_menus.findByPk(id, options);

        await app_menus.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await app_menus.destroy({
            transaction
        });

        return app_menus;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const app_menus = await db.app_menus.findOne(
            { where },
            { transaction },
        );

        if (!app_menus) {
            return app_menus;
        }

        const output = app_menus.get({plain: true});

        
        
        
        
        
        
        
        
        
        output.role_permissions_menu = await app_menus.getRole_permissions_menu({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.key) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'app_menus',
                        'key',
                        filter.key,
                    ),
                };
            }
            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'app_menus',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.route) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'app_menus',
                        'route',
                        filter.route,
                    ),
                };
            }
            
            if (filter.parent_key) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'app_menus',
                        'parent_key',
                        filter.parent_key,
                    ),
                };
            }
            

            
            

            
            if (filter.sort_orderRange) {
                const [start, end] = filter.sort_orderRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sort_order: {
                    ...where.sort_order,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_visible) {
                where = {
                    ...where,
                is_visible: filter.is_visible,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.app_menus.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'app_menus',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.app_menus.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

